from django.contrib.sites.models import Site
from django.conf import settings
from satchmo import caching
from threaded_multihost.middleware import ThreadLocalMiddleware
from threaded_multihost import threadlocals
import logging

log = logging.getLogger('cachedmiddleware')

class MultihostMiddleware(ThreadLocalMiddleware):

    def process_request(self, request):
        super(ThreadLocalMiddleware, self).process_request()
        
        host = request.META['HTTP_HOST']
        # strip the port
        host = host.split(":")[0]
        try:
            site = caching.cache_get('SITE', host=host)

        except caching.NotCachedError, nce:
            try:
                log.debug('looking up site by host: %s', host)
                site = Site.objects.get(domain=host)

            except Site.DoesNotExist:
                global _WARNED
                if not _WARNED:
                    log.warn("Site '%s' is not configured on this site - add to sites in admin", host)                
                    _WARNED = True
                
            if not site:
                site = Site.objects.get_current()
                
            caching.cache_set(nce.key, value=site)
            
        if site:
            settings.SITE_ID = site.id
            settings.SITE_NAME = site.name
            threadlocals.set_thread_variable("SITE", site)
